﻿Enumeration
  #cbc
EndEnumeration

Procedure WindowCallback(hWnd,uMsg,wParam,lParam)
  rect.RECT
  Result = #PB_ProcessPureBasicEvents

  Select uMsg

    Case #WM_COMMAND
      If (wParam>>16)&$FFFF=#CBN_SELCHANGE And lParam=GadgetID(#cbc)
        indexClick=SendMessage_(GadgetID(#cbc),#CB_GETCURSEL,0,0)
        ;Debug indexClick
        v.l=1-SendMessage_(GadgetID(#cbc),#CB_GETITEMDATA,indexClick,0)
        SendMessage_(GadgetID(#cbc),#CB_SETITEMDATA,indexClick,v)
        InvalidateRect_(GadgetID(#cbc),0,1)
      EndIf

    Case #WM_DRAWITEM
      *DrawItem.DRAWITEMSTRUCT = lParam
     
      If *DrawItem\CtlType = #ODT_COMBOBOX
        SetBkMode_(*DrawItem\hDC, #TRANSPARENT) ; Text is rendered transparent
        If *DrawItem\itemState&#ODS_FOCUS;#ODS_SELECTED
          SetTextColor_(*DrawItem\hdc,GetSysColor_(#COLOR_HIGHLIGHTTEXT))
          SetBkColor_(*DrawItem\hdc,GetSysColor_(#COLOR_HIGHLIGHT))
        Else
          SetTextColor_(*DrawItem\hdc,GetSysColor_(#COLOR_WINDOWTEXT))
          SetBkColor_(*DrawItem\hdc,GetSysColor_(#COLOR_WINDOW))
        EndIf
        ; Draw selected / unselected back color
        ExtTextOut_(*DrawItem\hdc,0,0,#ETO_OPAQUE,*DrawItem\rcItem,0,0,0)
        
        ; Draw the checkbox
        rect\left=*DrawItem\rcItem\left+1
        rect\right=*DrawItem\rcItem\left+14
        rect\top=*DrawItem\rcItem\top+1
        rect\bottom=*DrawItem\rcItem\top+14
        st.l=#DFCS_BUTTONCHECK|#DFCS_FLAT
        If *DrawItem\itemData
          st|#DFCS_CHECKED
        EndIf

        If *DrawItem\itemID <> -1
        DrawFrameControl_(*DrawItem\hdc,rect,#DFC_BUTTON,st)

          Text$ = Space(512)
          SendMessage_(*DrawItem\hwndItem, #CB_GETLBTEXT, *DrawItem\itemID, @Text$)
          TextOut_   (*DrawItem\hDC, *DrawItem\rcItem\left+17, *DrawItem\rcItem\top+1, Text$, Len(Text$))
        Else
          ;Debug "display"
          ;when cursle = -1
          SetTextColor_(*DrawItem\hdc,GetSysColor_(#COLOR_WINDOWTEXT))
				SetBkColor_(*DrawItem\hdc,GetSysColor_(#COLOR_WINDOW))
				t$="text to display";invoke get_combo_selects
				TextOut_(*DrawItem\hdc,8,*DrawItem\rcItem\top,t$,Len(t$));addr output_buf,eax
        EndIf
      EndIf
 
  EndSelect
 
  ProcedureReturn Result


EndProcedure


If OpenWindow(0, 0, 0, 270, 180, "ComboBoxGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  ComboBoxGadget(#cbc, 10, 10, 250, 21,#CBS_OWNERDRAWFIXED|#CBS_HASSTRINGS)
  
  For a = 0 To 3
    AddGadgetItem(#cbc, -1,"ComboBox item " + Str(a))
  Next
  SendMessage_(GadgetID(#cbc),#CB_SETITEMDATA,0,1)
  SendMessage_(GadgetID(#cbc),#CB_SETITEMDATA,2,1)
  
  SetWindowCallback(@WindowCallback())
  ;SetGadgetState(#cbc,3)

  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
EndIf

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 17
; FirstLine = 1
; Folding = -
; EnableUnicode
; EnableXP