
include t4.inc
include debug.inc
includelib debug.lib
.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax

    	invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

;########################################################################

combo_listbox proc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL curSel , rect:RECT ,itemHeight ,topIndex ,x,y ,indexClick
	
	.if uMsg==WM_LBUTTONUP
		xor eax,eax
		ret
	.elseif uMsg==LB_GETCURSEL
		mov eax,-1
		ret
	.elseif uMsg==WM_LBUTTONDOWN
		
		invoke SendMessage,hWin,LB_GETTOPINDEX,0,0
		mov topIndex,eax
		invoke SendMessage,hWin,LB_GETITEMHEIGHT,0,0
		mov itemHeight,eax
		
		mov eax,lParam
		mov edx,eax
		and eax,0FFFFh		;The low-order word specifies the x-coordinate of the cursor.
		mov x,eax
		shr edx,16		;The high-order word specifies the y-coordinate of the cursor.
		mov y,edx
		
		mov eax,y
		xor edx,edx
		idiv itemHeight
		add eax,topIndex
		mov indexClick,eax
		
;		.if sdword ptr eax >= 0
;			mov curSel,eax
			
			invoke SendMessage,hWin,LB_GETITEMRECT,indexClick,addr rect

			invoke PtInRect,addr rect,x,y
			.if eax
				invoke SendMessage,hwnd_combobox,CB_GETITEMDATA,indexClick,0
				btc eax,0
				invoke SendMessage,hwnd_combobox,CB_SETITEMDATA,indexClick,eax
				
				invoke InvalidateRect,hWin,0,TRUE	
				invoke InvalidateRect,hwnd_combobox,0,TRUE			
			.endif
			

;		.endif
	.endif
	
	invoke CallWindowProc,old_proc_combo_listbox,hWin,uMsg,wParam,lParam
	ret

combo_listbox endp

get_combo_selects proc 
	LOCAL count , temp
	
	invoke SendMessage,hwnd_combobox,CB_GETCOUNT,0,0
	mov count,eax
	
	xor ebx,ebx
	mov output_buf,0
	.while ebx < count
		invoke SendMessage,hwnd_combobox,CB_GETITEMDATA,ebx,0
		.if eax
			invoke ltoa,ebx,addr temp
			invoke lstrcat,addr output_buf,addr temp
			invoke lstrcat,addr output_buf,$CTA0("|")
		.endif
		
		inc ebx
	.endw
	
	invoke lstrlen,addr output_buf
	lea ebx,output_buf
	.if eax!=0
		mov byte ptr [ebx+eax-1],0	;clear the last |  and return the length for TextOut
	.endif
	
	ret

get_combo_selects endp

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL @buf[30] ,rect:RECT ,cboinfo:COMBOBOXINFO 
	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		invoke SendDlgItemMessage,hWin,IDC_CBO1,CB_ADDSTRING,0,$CTA0("000000000")
		invoke SendDlgItemMessage,hWin,IDC_CBO1,CB_ADDSTRING,0,$CTA0("111111")
		invoke SendDlgItemMessage,hWin,IDC_CBO1,CB_ADDSTRING,0,$CTA0("222")
		invoke SendDlgItemMessage,hWin,IDC_CBO1,CB_ADDSTRING,0,$CTA0("3333333")
		invoke SendDlgItemMessage,hWin,IDC_CBO1,CB_ADDSTRING,0,$CTA0("4444")
		invoke SendDlgItemMessage,hWin,IDC_CBO1,CB_ADDSTRING,0,$CTA0("55")
		invoke SendDlgItemMessage,hWin,IDC_CBO1,CB_ADDSTRING,0,$CTA0("6")
		invoke SendDlgItemMessage,hWin,IDC_CBO1,CB_ADDSTRING,0,$CTA0("7777")
		invoke SendDlgItemMessage,hWin,IDC_CBO1,CB_ADDSTRING,0,$CTA0("88")
		invoke SendDlgItemMessage,hWin,IDC_CBO1,CB_ADDSTRING,0,$CTA0("99")
		invoke SendDlgItemMessage,hWin,IDC_CBO1,CB_ADDSTRING,0,$CTA0("10")
		invoke SendDlgItemMessage,hWin,IDC_CBO1,CB_ADDSTRING,0,$CTA0("11")
		invoke SendDlgItemMessage,hWin,IDC_CBO1,CB_ADDSTRING,0,$CTA0("12")
		invoke SendDlgItemMessage,hWin,IDC_CBO1,CB_ADDSTRING,0,$CTA0("13")
		invoke SendDlgItemMessage,hWin,IDC_CBO1,CB_ADDSTRING,0,$CTA0("14")
				
		invoke SendDlgItemMessage,hWin,IDC_CBO1,CB_SETITEMDATA,0,TRUE
		invoke SendDlgItemMessage,hWin,IDC_CBO1,CB_SETITEMDATA,2,TRUE			
		
		invoke GetDlgItem,hWin,IDC_CBO1
		mov hwnd_combobox,eax
		
		mov cboinfo.cbSize,sizeof COMBOBOXINFO
		invoke GetComboBoxInfo,hwnd_combobox,addr cboinfo
		
		lea esi,cboinfo
		mov eax,(COMBOBOXINFO ptr [esi]).hwndList
		mov hwnd_combobox_listbox,eax
		
		invoke SetWindowLong,hwnd_combobox_listbox,GWL_WNDPROC,offset combo_listbox
		mov old_proc_combo_listbox,eax
		

	.elseif eax==WM_DRAWITEM
		.if wParam==IDC_CBO1
			mov esi,lParam
			assume esi:ptr DRAWITEMSTRUCT 

			mov eax,[esi].itemID
			.if sdword ptr eax >=0
			
				mov		eax,[esi].itemState
				test	eax,ODS_SELECTED
				.If !ZERO?
					invoke GetSysColor,COLOR_HIGHLIGHTTEXT
					invoke SetTextColor,[esi].hdc,eax
					invoke GetSysColor,COLOR_HIGHLIGHT
					invoke SetBkColor,[esi].hdc,eax
				.else
					invoke GetSysColor,COLOR_WINDOWTEXT
					invoke SetTextColor,[esi].hdc,eax
					invoke GetSysColor,COLOR_WINDOW
					invoke SetBkColor,[esi].hdc,eax
				.endif
				; Draw selected / unselected back color
				invoke ExtTextOut,[esi].hdc,0,0,ETO_OPAQUE,addr [esi].rcItem,NULL,0,NULL
				; Draw the checkbox
				mov		eax,[esi].rcItem.left
				inc		eax
				mov		rect.left,eax
				add		eax,13
				mov		rect.right,eax
				mov		eax,[esi].rcItem.top
				inc		eax
				mov		rect.top,eax
				add		eax,13
				mov		rect.bottom,eax
				mov		eax,DFCS_BUTTONCHECK Or DFCS_FLAT
				.If [esi].itemData
					; Checkbox is checked
					or		eax,DFCS_CHECKED
				.endif
				invoke DrawFrameControl,[esi].hdc,addr rect,DFC_BUTTON,eax				
				

				invoke SendMessage,[esi].hwndItem,CB_GETLBTEXT,[esi].itemID,addr @buf
				mov ecx,[esi].rcItem.left			
				add ecx,15
				invoke TextOut,[esi].hdc,ecx,[esi].rcItem.top,addr @buf,eax
			.else
				;when cursle = -1
				invoke GetSysColor,COLOR_WINDOWTEXT
				invoke SetTextColor,[esi].hdc,eax
				invoke GetSysColor,COLOR_WINDOW
				invoke SetBkColor,[esi].hdc,eax
				invoke get_combo_selects
				invoke TextOut,[esi].hdc,2,[esi].rcItem.top,addr output_buf,eax
			.endif
			
			assume esi:nothing
		
		
		.endif

	.elseif eax==WM_COMMAND
		mov eax,wParam
		and eax,0ffffh


	.elseif eax==WM_CLOSE
		invoke EndDialog,hWin,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

end start
